<template src="./createAttributesComponent.htm"></template>

<script>

    import Vue from 'vue';
    import VueBootstrapTypeahead from 'vue-bootstrap-typeahead';
    import VueTagsInput from '@johmun/vue-tags-input';
    import combos from 'combos';
    import ValidationErrorsMixin from '../../../../../mixins/validationErrorsMixin.js';

    export default {

        mounted() {

            this.setSelectedWarehouse();
        },

        data() {

            return {

                productAttributes: [

                    { name: '', lastInsertedTag: '', values: [] }
                ],

                variants: [],

                selectedWarehouse: null
            }
        },

        mixins: [ ValidationErrorsMixin ],

        components: { VueBootstrapTypeahead, VueTagsInput },

        methods: {

            /**
             * Set selected warehouse (first from array as default).
             */
            setSelectedWarehouse() {

                this.selectedWarehouse = this.warehouses.length > 0 ? this.warehouses[0] : null;
            },


            /**
             * Add new attribute.
            */
            addProductAttribute() {

                this.productAttributes.push({ name: '', lastInsertedTag: '', values: [] });
            },


            /**
             * Remove given attribute.
             *
             * @param index
            */
            removeProductAttribute(index) {

                this.productAttributes.splice(index, 1);

                this.updateAutocompleteInputValues();
            },


            /**
             * Manually change autocomplete component inputValue attributes since reactivity is failing (value is ok)
             */
            updateAutocompleteInputValues() {

                this.$refs.attributesAutocomplete.forEach( (el, i) => el.inputValue = this.productAttributes[i].name);
            },


            /**
             * Create all variants combinations from given attributes.
             *
             * @param productAttributes
             */
            createVariants(productAttributes) {

                this.variants       = [];
                const comboObject   = {};

                if (productAttributes.length > 0) {

                    /**
                     * Get only completed attributes from list.
                     */
                    let filteredAttributes = productAttributes.filter( (el) => el.name != '' && el.values.length > 0);

                    if (filteredAttributes.length > 0) {

                        /**
                         * Map attribute name to its values.
                         */
                        filteredAttributes.forEach( (el) => comboObject[el.name] = el.values.map( (value) => value.text));


                        /**
                         * Fill variants with all possible combinations of attributes and values.
                         */
                        combos(comboObject).forEach( (combo) => this.pushVariantObject(combo));
                    }
                }
            },


            /**
             * Create and push object to variants array with given combination.
             **/
            pushVariantObject(combination) {

                this.variants.push({

                    "attributes-values": combination,

                    sku: '',

                    price: 0,

                    warehouses: this.createWarehousesArray()
                });
            } ,


            /**
             * Create default warehouses value for variants in order to pass by value not references.
             */
            createWarehousesArray() {

                return this.warehouses.map( (el) => {

                    return {

                        id: el.id,
                        quantity: 0
                    }
                });
            }
        },

        computed: {

            /**
             * If there is unfilled attribute disable button for adding new one.
             */
            disabledAddButton() {

                return this.productAttributes.find( (el) => el.name === '' || el.values.length < 1);
            },


            /**
             * Return all warehouses from store.
            **/
            warehouses() {

                return this.$store.state.warehouses;
            },


            /**
             * Return all attributes for autocomplete component from store.
             **/
            autocompleteAttributes() {

                return this.$store.getters.autocompleteAttributes;
            }
        },

        watch: {

            /**
             * Create variants on attributes-values changes.
             **/
            productAttributes: {

                handler(newProductAttributes) {

                    this.createVariants(newProductAttributes);
                },

                deep: true
            },


            /**
             * Update vuex store with latest variants.
             *
             * @param newVariants
             */
            variants(newVariants) {

                this.$store.dispatch('setProductVariants', newVariants);
            },


            /**
             * Set default warehouse in table.
             */
            warehouses() {

                this.setSelectedWarehouse();
            }
        }
    }

</script>